/* $Id: help.c,v 4.4.3.1 1992/02/01 03:09:32 sob PATCH_3 sob $
 *
 * $Log: help.c,v $
 * Revision 4.4.3.1  1992/02/01  03:09:32  sob
 * Release 4.4 Patchlevel 3
 *
 * Revision 4.4.2.1  1991/12/01  18:05:42  sob
 * Patchlevel 2 changes
 *
 * Revision 4.4  1991/09/09  20:18:23  sob
 * release 4.4
 *
 *
 * 
 */
/* This software is Copyright 1991 by Stan Barber. 
 *
 * Permission is hereby granted to copy, reproduce, redistribute or otherwise
 * use this software as long as: there is no monetary profit gained
 * specifically from the use or reproduction of this software, it is not
 * sold, rented, traded or otherwise marketed, and this copyright notice is
 * included prominently in any copy made. 
 *
 * The author make no claims as to the fitness or correctness of this software
 * for any use whatsoever, and it is provided as is. Any use of this software
 * is at the user's own risk. 
 */

#include "EXTERN.h"
#include "common.h"
#include "rn.h"
#include "term.h"
#include "INTERN.h"
#include "help.h"

void
help_init()
{
    ;
}

int
help_page()
{
    int cmd;

#ifdef PAGERHELP
    doshell(sh,filexp(PAGERHELP));
#else
    page_init();
    if ((cmd = print_lines("\
Paging commands:\n\
",STANDOUT)) ||
    (cmd = print_lines("\n\
SP	Display the next page.\n\
x	Display the next page decrypted (rot13).\n\
d	Display half a page more.\n\
CR	Display one more line.\n\
^R,v,^X	Restart the current article (v=verbose header, ^X=rot13).\n\
",NOMARKING)) ||
    (cmd = print_lines("\
b	Back up one page.\n\
^L,X	Refresh the screen (X=rot13).\n\
",NOMARKING)) ||
#ifdef USETHREADS
    (cmd = print_lines("\
t	Display the entire article tree and all its subjects.\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
g pat	Go to (search forward within article for) pattern.\n\
G	Search again for current pattern within article.\n\
^G	Search for next line beginning with \"Subject:\".\n\
TAB	Search for next line beginning with a different character.\n\
q	Quit the pager, go to end of article.  Leave article read or unread.\n\
j	Junk this article (mark it read).  Goes to end of article.\n\
\n\
",NOMARKING)) ||
    (cmd = print_lines("\
The following commands skip the rest of the current article, then behave\n\
just as if typed to the 'What next?' prompt at the end of the article:\n\
",STANDOUT)) ||
    (cmd = print_lines("\n\
n	Scan forward for next unread article.\n\
N	Go to next article.\n\
^N	Scan forward for next unread article with same title.\n\
p,P,^P	Same as n,N,^N, only going backwards.\n\
-	Go to previously displayed article.\n\
",NOMARKING)) ||
#ifdef USETHREADS
    (cmd = print_lines("\
<,>	Browse the previous/next selected thread.  If no threads are selected,\n\
	all threads that had unread news upon entry to the group are considered\n\
	selected for browsing.  Entering an empty group browses all threads.\n\
[,],{,} Go to parent/child/root/leaf in thread.\n\
(,)	Go to article's previous/next sibling.\n\
\n\
",NOMARKING)) ||
#endif
#ifdef SCAN
    (cmd = print_lines("\
;	Enter ScanArticle mode.\n\
",NOMARKING)) ||
#endif
#ifdef SCORE
    (cmd = print_lines("\
Scoring commands are enabled.\n\
(Type h at end of article for description of Scoring commands.)\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
The following commands also take you to the end of the article.\n\
Type h at end of article for a description of these commands:\n\
",STANDOUT)) ||
#ifdef USETHREADS
    (cmd = print_lines("\
	# $ & / = ? c C f F k K ^K J , m M number e r R ^R s S u U v w W Y ^ |\n\
\n\
(To return to the middle of the article after one of these commands, type ^L.)\n\
",NOMARKING)) )
#else
    (cmd = print_lines("\
	# $ & / = ? c C f F k K ^K m M number e r R ^R s S u v w W Y ^ |\n\
\n\
(To return to the middle of the article after one of these commands, type ^L.)\n\
",NOMARKING)) )
#endif
	return cmd;
#endif
    return 0;
}

int
help_art()
{
    int cmd;
#ifdef ARTHELP
    doshell(sh,filexp(ARTHELP));
#else
    page_init();
    if ((cmd = print_lines("\
Article Selection commands:\n\
",STANDOUT)) ||
#ifdef USETHREADS
    (cmd = print_lines("\n\
n,SP	Find next unread article (follows discussion-tree in threaded groups).\n\
",NOMARKING)) ||
#else
    (cmd = print_lines("\n\
n,SP	Scan forward for next unread article.\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
N	Go to next article.\n\
^N	Scan forward for next unread article with same subject.\n\
p,P,^P	Same as n,N,^N, only going backwards.\n\
-	Go to previously displayed article.\n\
",NOMARKING)) ||
#ifdef USETHREADS
    (cmd = print_lines("\
<,>	Browse the previous/next selected thread.  If no threads are selected,\n\
	all threads that had unread news upon entry to the group are considered\n\
	selected for browsing.  Entering an empty group browses all threads.\n\
[,]	Go to article's parent/child.\n\
{,}	Go to tree's root/leaf.\n\
(,)	Go to article's previous/next sibling.\n\
t	Display the entire article tree and all its subjects.\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
number	Go to specified article.\n\
range{,range}:command{:command}\n\
	Apply one or more commands to one or more ranges of articles.\n\
	Ranges are of the form: number | number-number.  You may use . for\n\
	the current article, and $ for the last article.\n\
",NOMARKING)) ||
#ifdef USETHREADS
    (cmd = print_lines("\
 	Valid commands are: e, j, m, M, s, S, t, T, |, +, and -.\n\
:cmd	Perform a command on all the selected articles.\n\
",NOMARKING)) ||
#else
    (cmd = print_lines("\
 	Valid commands are: e, j, m, M, s, S, and |.\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
/pattern/modifiers\n\
	Scan forward for article containing pattern in the subject line.\n\
	(Use ?pat? to scan backwards; append h to scan headers, a to scan\n\
	entire articles, r to scan read articles, c to make case sensitive.)\n\
",NOMARKING)) ||
    (cmd = print_lines("\
/pattern/modifiers:command{:command}\n\
	Apply one or more commands to the set of articles matching pattern.\n\
	Use a K modifier to save entire command to the KILL file for this\n\
	newsgroup.  Commands m and M, if first, imply an r modifier.\n\
 	Valid commands are the same as for the range command.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
f,F	Submit a followup article (F = include this article).\n\
r,R	Reply through net mail (R = include this article).\n\
e dir{|command}\n\
	Extract to directory using /bin/sh, uudecode, unship, or command.\n\
s ...	Save to file or pipe via sh.\n\
S ...	Save via preferred shell.\n\
w,W	Like s and S but save without the header.\n\
| ...	Same as s|...\n\
",NOMARKING)) ||
    (cmd = print_lines("\
C	Cancel this article, if yours.\n\
^R,v	Restart article (v=verbose).\n\
^X	Restart article, rot13 mode.\n\
c	Catch up (mark all articles as read).\n\
b	Back up one page.\n\
^L	Refresh the screen.  You can get back to the pager with this.\n\
X	Refresh screen in rot13 mode.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
^	Go to first unread article.  Disables subject search mode.\n\
$	Go to end of newsgroup.  Disables subject search mode.\n\
",NOMARKING)) ||
    (cmd = print_lines("#       Print last article number.\n\
&	Print current values of command-line switches.\n\
&switch {switch}\n\
	Set or unset more switches.\n\
&&	Print current macro definitions.\n\
&&def	Define a new macro.\n\
j	Junk this article (mark it read).  Stays at end of article.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
m	Mark article as still unread.\n\
M	Mark article as still unread upon exiting newsgroup or Y command.\n\
Y	Yank back articles marked temporarily read via M.\n\
k	Kill current subject (mark articles as read).\n\
",NOMARKING)) ||
#ifdef USETHREADS
    (cmd = print_lines("\
,	Mark current article and its replies as read.\n\
J	Junk entire thread (mark all subjects as read in this thread).\n\
T	Trash current thread (like 'J'), and save command in KILL file.\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
K	Mark current subject as read, and save command in KILL file.\n\
^K	Edit local KILL file (the one for this newsgroup).\n\
=	List subjects of unread articles.\n\
",NOMARKING)) ||
#ifdef USETHREADS
    (cmd = print_lines("\
+	Enter thread selection mode.\n\
U	Unread some news -- prompts for thread, subthread, all, or select.\n\
",NOMARKING)) ||
#endif
#ifdef SCAN
    (cmd = print_lines("\
;	Enter ScanArticle mode.\n\
",NOMARKING)) ||
#endif
#ifdef SCORE
    (cmd = print_lines("\
\"\" <text>\n\
	Adds <text> to the local (this newsgroup's) scorefile.\n\
\"C <text>\n\
	Adds <text> to the scorefile represented by the abbreviation C.\n\
\"?	List all scorefile abbreviations and the filenames they represent.\n\
\"! <text>\n\
	Adds <text> to the internal list of scoring rules as if it was read\n\
	from a file.  Articles are rescored after this command.\n\
'd	Debugging dump.  (Will go away in later versions.)\n\
'e <abbreviation OR filename>\n\
	Edits the scorefile named by the following file abbreviation\n\
	character or full filename.  If no arguments are given, edits the\n\
	local scorefile (the one for the current newsgroup).\n\
'f	Continue scoring articles until interrupted.\n\
'r	Discard old scoring data and rescore from score files.\n\
's	Show scoring rules which contributed to this article's score.\n\
't	Test command: may do varying things.  (will usually be disabled)\n\
",NOMARKING)) ||
#ifdef NEWSFILTER
    (cmd = print_lines("\
'n <text>\n\
	Send <text> to Newsclip command procedure.\n\
",NOMARKING)) ||
#endif
#endif /* SCORE */
    (cmd = print_lines("\
u	Unsubscribe from this newsgroup.\n\
q	Quit this newsgroup for now.\n\
Q	Quit newsgroup, staying at current newsgroup.\n\
",NOMARKING)) )
	return cmd;
#endif
    return 0;
}

int
help_ng()
{
    int cmd;
#ifdef NGHELP
    doshell(sh,filexp(NGHELP));
#else
    page_init();
    if (cmd = print_lines("\
Newsgroup Selection commands:\n\
",STANDOUT) )
	return cmd;
    if (ng != nextrcline) {
	if ((cmd = print_lines("\
\n\
y,SP	Do this newsgroup now.\n\
.cmd	Do this newsgroup, executing cmd as first command.\n\
",NOMARKING)) ||
#ifdef SCAN
    (cmd = print_lines("\
;	Enter ScanArticle mode for this newsgroup.\n\
:	Enter ScanGroup mode.\n\
",NOMARKING)) ||
#endif
#ifdef USETHREADS
    (cmd = print_lines("\
+	Enter this newsgroup through the thread selector (like typing .+<CR>).\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
=	Start this newsgroup, but list subjects before reading articles.\n\
",NOMARKING)) ||
#ifdef USETHREADS
    (cmd = print_lines("\
U	Enter this newsgroup by way of the \"Set unread?\" prompt.\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
u	Unsubscribe from this newsgroup.\n\
",NOMARKING)) )
	    return cmd;
    }
    if ((cmd = print_lines("\
c	Catch up (mark this newsgroup all read).\n\
A	Abandon read/unread changes to this newsgroup since you started trn.\n\
\n\
n	Go to the next newsgroup with unread news.\n\
N	Go to the next newsgroup.\n\
p	Go to the previous newsgroup with unread news.\n\
P	Go to the previous newsgroup.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
-	Go to the previously displayed newsgroup.\n\
1	Go to the first newsgroup.\n\
^	Go to the first newsgroup with unread news.\n\
$	Go to the last newsgroup.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
g name	Go to the named newsgroup.  Subscribe to new newsgroups this way too.\n\
/pat	Search forward for newsgroup matching pattern.\n\
?pat	Search backward for newsgroup matching pattern.\n\
	(Use * and ? style patterns.  Append r to include read newsgroups.)\n\
",NOMARKING)) ||
    (cmd = print_lines("\
l pat	List unsubscribed newsgroups containing pattern.\n\
m name	Move named newsgroup elsewhere (no name moves current newsgroup).\n\
o pat	Only display newsgroups matching pattern.  Omit pat to unrestrict.\n\
a pat	Like o, but also scans for unsubscribed newsgroups matching pattern.\n\
L	List current .newsrc.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
&	Print current command-line switch settings.\n\
&switch {switch}\n\
	Set (or unset) more command-line switches.\n\
&&	Print current macro definitions.\n\
&&def	Define a new macro.\n\
!cmd	Shell escape.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
q	Quit trn.\n\
x	Quit, restoring .newsrc to its state at startup of trn.\n\
^K	Edit the global KILL file.  Use commands like /pattern/j to suppress\n\
	pattern in every newsgroup.\n\
v	Print version.\n\
",NOMARKING)) )
	return cmd;
#endif
#ifdef PUSHBACK
    if (cmd = get_anything())
	return cmd;
    show_macros();
#endif
    return 0;
}

#ifdef ESCSUBS
int
help_subs()
{
    int cmd;
#ifdef SUBSHELP
    doshell(sh,filexp(SUBSHELP));
#else
    page_init();
    if ((cmd = print_lines("\
Valid substitutions are:\n\
",STANDOUT)) ||
    (cmd = print_lines("\
\n\
a	Current article number\n\
A	Full name of current article (%P/%c/%a)\n\
b	Destination of last save command, often a mailbox\n\
B	Bytes to ignore at beginning of last saved article\n\
",NOMARKING)) ||
    (cmd = print_lines("\
c	Current newsgroup, directory form\n\
C	Current newsgroup, dot form\n\
d	Full name of newsgroup directory (%P/%c)\n\
D	Distribution line from current article\n\
e	The last command executed to extract data from an article\n\
E	The last extraction directory\n\
",NOMARKING)) ||
    (cmd = print_lines("\
f	Who the current article is from\n\
F	Newsgroups to followup to (from Newsgroups and Followup-To)\n\
h	(This help message)\n\
H	Host name (yours)\n\
i	Message-I.D. line from current article, with <>\n\
I	Reference indicator mark (see -F switch)\n\
",NOMARKING)) ||
    (cmd = print_lines("\
l	News administrator's login name, if any\n\
L	Login name (yours)\n\
",NOMARKING)) ||
#ifdef USETHREADS
    (cmd = print_lines("\
m	Current mode, first letter of (init,newsgroup,thread,article,pager,\n\
		unread,Add,Catchup,Delete-bogus,Mailbox,Resubscribe)\n\
",NOMARKING)) ||
#else
    (cmd = print_lines("\
m	Current mode, first letter of (init, newsgroup, article, pager,\n\
		Add, Catchup, Delete bogus, Mailbox, Resubscribe)\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
M	Number of article marked with M\n\
n	Newsgroups from current article\n\
N	Full name (yours)\n\
o	Organization (yours)\n\
O	Original working directory (where you ran trn from)\n\
",NOMARKING)) ||
    (cmd = print_lines("\
p	Your private news directory (from -d)\n\
P	Public news spool directory\n\
r	Last reference (parent article id)\n\
R	References list for followup article\n\
",NOMARKING)) ||
    (cmd = print_lines("\
s	Subject, with all Re's and (nf)'s stripped off\n\
S	Subject, with one Re stripped off\n\
t	New To line derived from From and Reply-To (Internet format)\n\
T	New To line derived from Path\n\
u	Number of unread articles\n\
",NOMARKING)) ||
#ifdef USETHREADS
    (cmd = print_lines("\
U	Number of unread articles not counting the current article (when\n\
	threads are selected, the count only reflects selected articles)\n\
v	The number of extra (unselected) articles, not counting the current\n\
	one if it is unselected\n\
w	Mthreads' tmp directory\n\
W	Where thread files are saved\n\
x	News library directory\n\
X	Trn library directory\n\
z	Length of current article in bytes\n\
Z	Number of selected threads\n\
",NOMARKING)) ||
#else
    (cmd = print_lines("\
U	Number of unread articles not counting the current article\n\
x	News library directory\n\
X	Trn library directory\n\
z	Length of current article in bytes\n\
",NOMARKING)) ||
#endif
#ifdef SCORE
    (cmd = print_lines("\
y	From line with the domain abbreviated.\n\
	(foo@x.y.bar.edu (Foo's Bar) -> foo@*.bar.edu (Foo's Bar))\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
~	Your home directory\n\
.	Directory containing . files\n\
#	A counter in multi-article saves\n\
$	Current process number\n\
/	Last search string\n\
ESC	Run preceding command through % interpretation\n\
",NOMARKING)) )
	return cmd;
#endif
    return 0;
}
#endif

#ifdef USETHREADS
int
help_select()
{
    int cmd;

    page_init();
    if ((cmd = print_lines("\
Thread selection commands:\n\
",STANDOUT)) ||
    (cmd = print_lines("\n\
a-z,0-9	Select/deselect the discussion thread by its letter or number.  By\n\
	default the letters h, k, m, n, p, q and y are omitted.\n\
SP	Perform the default command (usually > or Z).\n\
CR	Start reading.  Selects the current thread if none are selected.\n\
Z,TAB	Start reading.  If no articles are selected, read everything.\n\
y, '.'	Toggle the current thread's selection.\n\
k, ','	Mark the current thread as killed.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
m, \\	Unmark the current thread.\n\
-	Set a range, as in 2 - 5.  Repeats the last marking action.\n\
@	Toggle all visible thread selections.\n\
n, ]	Move down to the next thread.\n\
p, [	Move up to the previous thread.\n\
<, >	Go to previous/next page.\n\
^, $	Go to first/last page.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
X	Mark all unselected articles as read and start reading.\n\
D	Mark unselected articles on the current page as read.  Start\n\
	reading if articles were selected, else go to next page.\n\
J	Junk all selected articles (mark them as read).\n\
c	Catch up -- marks ALL articles as read without chasing xrefs.\n\
^K	Edit local KILL file (the one for this newsgroup).\n\
:cmd	Perform a command on all the selected articles.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
/pattern/modifiers\n\
	Scan all articles for a subject containing pattern.\n\
	(Append h to scan headers, a to scan entire articles, c to make case\n\
	sensitive, r to scan read articles (assumed when you are selecting\n\
	read articles to set unread.)\n\
/pattern/modifiers:command{:command}\n\
	Apply one or more commands to the set of articles matching pattern.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
	Use a K modifier to save entire command to the KILL file for this\n\
	newsgroup.  Commands m and M, if first, imply an r modifier.\n\
 	Valid commands are: e, E, j, m, M, s, S, t, T, !, =, ',' and the\n\
	thread selection commands: + and -.\n\
N	Leave this group as-is and go on to the next.\n\
U	Switch between selecting read/unread articles.\n\
L	Switch the current display mode between a terse mode without\n\
	authors and a short and long mode with authors.\n\
",NOMARKING)) ||
#ifdef SCAN
    (cmd = print_lines("\
;	Enter ScanArticle mode.  If there are any selected threads\n\
	ScanArticle will \"zoom\" into those threads.\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
&	View or set command line switches.\n\
&&	View or set macro definitions.\n\
!cmd	Escape to a subshell.\n\
q	Quit selection mode.\n\
Q	Quit group and return to news group selection prompt for this group.\n\
",NOMARKING)) )
	return cmd;
    return 0;
}
#endif

#ifdef SCAN
int
help_scanart()
{
    int cmd;
#ifdef UNDEF
/* implement this later? */
    doshell(sh,filexp(SAHELP));
#else
    page_init();
    if ((cmd = print_lines("\
ScanArticle (SA) commands:\n\
",STANDOUT)) ||
    (cmd = print_lines("\
SP,CR	Display article, and enter the Article Level.\n\
	Note: Marked articles (see 'm') will be displayed first.\n\
r	Read the pointed-to article, ignoring marked articles.\n\
	(If there are marked articles, they will be read after the\n\
	 pointed-to article.)  (this description needs rewriting :-)\n\
",NOMARKING)) ||
    (cmd = print_lines("\
n,]	Move down to next line.\n\
^N	Move down to next occurrence of same subject.\n\
p,[	Move up to previous line.\n\
^p	Move up to previous article with the same subject.\n\
>	Display next page of articles.\n\
<	Display previous page of articles.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
t	Move to top of current page.\n\
b	Move to bottom of current page.\n\
T,^	Move to top of all articles.\n\
B,$	Move to bottom of all articles.\n\
N	Go to next newsgroup.\n\
P	Go to previous newsgroup.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
^L,^R	Redraw screen.\n\
k	Junk all articles (after pointer) with same subject.\n\
	(much the same as 'k' at the Article Selection Level.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
m	Mark or unmark article.  When entering the\n\
	Selection level, the next marked article will be read.\n\
M	Toggle mark on following articles with same subject.\n\
	(This is the same as typing 'm' on each of them.)\n\
X	Junk (mark as read) all unmarked articles.\n\
D	Junk unmarked articles on the same page. (similar to 'X')\n\
	['X' and 'D' act like the TRN thread selector options.]\n\
J	Junk marked articles on page.  (opposite of 'D')\n\
",NOMARKING)) ||
    (cmd = print_lines("\
s	Select (for zoom) this article.\n\
S	Select (for zoom) all following articles with same subject.\n\
Z	Clear (Zero) the zoom selections\n\
	[Note: when in zoom mode commands which delete articles will\n\
	only delete selected articles.  This means, for instance, that\n\
	'X' will only delete selected unmarked articles.  Useful for\n\
	reading only a few articles from a thread.]\n\
",NOMARKING)) ||
#ifdef USETHREADS
    (cmd = print_lines("\
+	Enter thread selection mode. (only if group is threaded)\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
h	Print this help.\n\
q	Quit reading this newsgroup and go to the next one.\n\
Q	Leave ScanArticle mode and read articles, starting with the\n\
	article pointed to.  You will not return to SA mode unless\n\
	you type ';' again.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
f	Toggle subject following mode.  When enabled article threads\n\
	will be followed normally.  When disabled typing space or\n\
	return at end of article will return to SA mode.\n\
	Typing a command explicitly (like ^n) will still work.\n\
	(If an explicit command is typed, follow mode will be temporarily\n\
	turned on for the remainder of the thread.)\n\
F	Toggle subject Folding mode.  (show only first article with a\n\
	subject.  Note that \"first\" depends on ordering...)\n\
z	Zoom toggle (show only \"selected\" articles in zoom mode.  Zoom\n\
	mode is automatically entered when SA mode is entered from the\n\
	TRN thread selector.)\n\
",NOMARKING)) ||
    (cmd = print_lines("\
!	Debugging information.  (will be disabled later)\n\
&	Debugging command. (will be disabled later)\n\
",NOMARKING)) ||
#ifdef SCORE
    (cmd = print_lines("\
K	Kill articles with scores *at* or below a number.\n\
	Type the threshold and press return.  (no spaces: type K-12)\n\
^E	Edit the score file for the current group.\n\
o	Toggle article ordering: arrival or score-sorted.\n\
O	Toggle article ordering between older-first and newer-first\n\
	when in score-sorted order.  (For two articles with same\n\
	score, toggle between the older one first or the newer one first.)\n\
R	Rescores all articles.  (same as 'r at article level).\n\
A	Toggles the author status column.  ('*' shows that an unscored\n\
	author has more than one article eligible in current mode).\n\
",NOMARKING)) ||
#endif
    (cmd = print_lines("\
U	Toggle reading eligibility: read / unread+read\n\
TAB	Toggle display of \"threadcount\" (# of articles following this one\n\
	with the same subject)\n\
a	Toggle display of authors.\n\
#	Toggle display of article numbers.\n\
",NOMARKING)) )
	return cmd;
#endif /* !UNDEF (later the !doshell part) */
    return 0;
}

int
help_scangroup()
{
    int cmd;
#ifdef UNDEF
/* implement this later? */
    doshell(sh,filexp(SGHELP));
#else
    page_init();
    if ((cmd = print_lines("\
ScanGroup (SG) commands:\n\
",STANDOUT)) ||
    (cmd = print_lines("\
ScanGroup is still an unfinished mode, so it has few commands.\n\
See the documentation for further discussion.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
SP,CR	Read newsgroup or enter list/file pointed to.\n\
	Newsgroups will be read using ScanArticle mode.\n\
;	Read newsgroup using ScanArticle mode, or enter list/file.\n\
+	Read newsgroup using trn's thread selector, or enter list/file.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
n,]	Move down to next line.\n\
^N	Move down to next occurrence of same subject.\n\
p,[	Move up to previous line.\n\
^p	Move up to previous article with the same subject.\n\
>	Display next page of articles.\n\
<	Display previous page of articles.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
t	Move to top of current page.\n\
b	Move to bottom of current page.\n\
T,^	Move to top of all articles.\n\
B,$	Move to bottom of all articles.\n\
",NOMARKING)) ||
    (cmd = print_lines("\
^L,^R	Redraw screen.\n\
(	Return to the previous level.\n\
q	Quit the current level.  If at the Top Level, quits strn.\n\
	(The Top Level behavior may change.)\n\
Q	Quit ScanGroup mode and return to trn's newsgroup selection mode.\n\
L	List (toggle) newsgroup descriptions (if available)\n\
^E	Edit the current topic (hierarchy) file.\n\
",NOMARKING)) )
	return cmd;
#endif /* !UNDEF (later the !doshell part) */
    return 0;
}
#endif /* SCAN */
