/* nov.c
 *
 * Routines for using the News OverView database by Geoff Collyer.
 *
 * Copyright 1992 by Clifford A. Adams
 */

#include "EXTERN.h"
#include "common.h"
#include "rn.h"			/* ngname */
#include "util.h"
#include "INTERN.h"
#include "nov.h"

bool
use_nov(groupname)
char *groupname;
{
    if (nov_opened) {
	if (strEQ(groupname,nov_open_group))
	    return(TRUE);	/* already open */
	unuse_nov();	/* close the other data */
    }
    nov_open_group = savestr(groupname);
    printf("\nOpening nov database...\n") FLUSH;
#ifndef SERVER
    novgp = novopen(groupname);
#else
    novgp = NULL;		/* No standard NNTP call */
#endif
    if (novgp == NULL) {
#ifndef SERVER
	printf("\nNov database open failed.\n") FLUSH;
#endif
	return(FALSE);
    }
    novallp = novall(novgp);
    if (novallp == NULL) {
	printf("Novall call failed after successful open.\n") FLUSH;
	return(FALSE);
    }
    novthread(novgp);
    nov_opened = TRUE;
    printf("Nov database opened successfully!\n") FLUSH;
    return(TRUE);
}

void
unuse_nov()
{
    if (!nov_opened)
	return;
    novclose(novgp);
    nov_opened = FALSE;
    free(nov_open_group);
    nov_open_group = (char*)NULL;
}

