/* This file Copyright 1992 by Clifford A. Adams */
/* samain.h
 *
 * Main routines for Screen-Scan mode.
 */

/* misc. buffer */
EXT char sa_buf[1024];

/* sa_per defn moved to scanart.h */

/* sa_art_status character bitmap:
 * 0: "marked" (for reading)
 * 1: Selection 1 (main selection)
 * 2: Selection 2 (aux. selection)
 * 3: Author is a scored one.
 */
#define sa_mark(a) sa_per_art[AOFFSET(a)].sa_art_status |= 1
#define sa_clearmark(a) sa_per_art[AOFFSET(a)].sa_art_status &= 0xfe
#define sa_marked(a) (sa_per_art[AOFFSET(a)].sa_art_status & 1)

#define sa_select1(a) sa_per_art[AOFFSET(a)].sa_art_status |= 2
#define sa_clearselect1(a) sa_per_art[AOFFSET(a)].sa_art_status &= 0xfd
#define sa_selected1(a) (sa_per_art[AOFFSET(a)].sa_art_status & 2)

#define sa_select2(a) sa_per_art[AOFFSET(a)].sa_art_status |= 4
#define sa_clearselect2(a) sa_per_art[AOFFSET(a)].sa_art_status &= 0xfb
#define sa_selected2(a) (sa_per_art[AOFFSET(a)].sa_art_status & 4)

#define sa_setauthscored(a) sa_per_art[AOFFSET(a)].sa_art_status |= 8
#define sa_clearauthscored(a) sa_per_art[AOFFSET(a)].sa_art_status &= 0xf7
#define sa_authscored(a) (sa_per_art[AOFFSET(a)].sa_art_status & 8)

/* initialize SCAN context */
void sa_init_context ANSI((void));

/* initialize article arrays (returns FALSE on failure) */
bool_int sa_initarts ANSI((void));

/* initialize modal differences */
void sa_initmode ANSI((void));

/* overall initialization (internal...) */
/* main loop (:-) */
int  sa_mainloop ANSI((void));

/* add more articles which arrived while reading group... */
/* arguments: old lastart, new lastart */
void sa_growarts ANSI((ART_NUM,ART_NUM));

/* clean up stuff */
void sa_cleanmain ANSI((void));

/* TRUE if in "zoom" (display only selected) mode */
EXT bool sa_mode_zoom INIT(FALSE);

/* TRUE if in "savimode" */
/* in "savimode" use j/k to move up and down */
EXT bool sa_mode_vi	INIT(FALSE);

#ifdef USETHREADS
/* TRUE if one should use "speed over accuracy" mode */
EXT bool sa_speed_over_acc INIT(FALSE);
#endif

/* if TRUE, don't move the cursor after marking or selecting articles */
EXT bool sa_mark_stay INIT(TRUE);

/* look-ahead function (while !input_pending()) */
void sa_lookahead ANSI((void));

ART_NUM sa_readmarked_elig ANSI((void));

int sa_debug_value INIT(0);
