/* This file Copyright 1992 by Clifford A. Adams */
/* scanart.c
 *
 * ScanArticle: screen oriented article interface based on old "SubScan" mode.
 * Interface routines to the rest of [t]rn
 */

#include "EXTERN.h"
#include "common.h"
#ifdef SCAN
#include "ng.h"		/* variable art, the next article to read. */
#include "term.h"	/* macro to clear... */
#include "bits.h"	/* absfirst */
#include "artsrch.h"	/* needed for artstate.h */
#include "artstate.h"	/* for reread */
#include "scan.h"
#include "spage.h"
#include "INTERN.h"
#include "scanart.h"		/* ordering dependency */
#include "EXTERN.h"
#include "samain.h"
#include "samisc.h"
#include "INTERN.h"

int
sa_main()
{
    char sa_oldmode;	/* keep mode of caller */
    int i;

    sa_in = TRUE;
    sa_go = FALSE;	/* ...do not collect $200... */
    sa_follow_temp = FALSE;

    if (!sa_initialized) {
	sa_init();
	if (!sa_initialized)		/* still not working... */
	    return(SA_ERR);		/* we don't belong here */
    }
    sa_never_initialized = FALSE;	/* we have entered at least once */

    /* unless "explicit" entry, read any marked articles */
    if (!sa_go_explicit) {
	ART_NUM a;
	a=sa_readmarked_elig();
	if (a) {	/* there was an article */
	    art = a;
	    reread = TRUE;
	    sa_clearmark(a);
	    return(SA_NORM);
	}
    }
    sa_go_explicit = FALSE;

    if (sa_do_selthreads) {
	sa_selthreads();
	sa_do_selthreads = FALSE;
	sa_mode_zoom = TRUE;		/* zoom in by default */
	*s_top_ent = -1;		/* go to top of arts... */
    }

    sa_oldmode = mode;			/* save mode */
    mode = 's';				/* for RN macros */
    i = sa_mainloop();
    mode = sa_oldmode;			/* restore mode */

    if ((i==SA_NORM) || (i==SA_FAKE)) {
	art = sa_art;
	if (sa_mode_read_elig)
	    reread = TRUE;
    }
    return(i);
}

/* called when more articles arrive */
void
sa_morearts(oldlast,last)
ART_NUM oldlast,last;
{
    if (!sa_initialized)
	return;				/* shouldn't happen */
    printf("entry: sa_morearts(%d,%d)\n",oldlast,last) FLUSH;
    fflush(stdout);	/* make SURE it is printed now! */
    sa_growarts(oldlast,last);
    printf("exit: sa_morearts(%d,%d)\n",oldlast,last) FLUSH;
}

void
sa_cleanup()
{
    if (!sa_initialized)		/* shouldn't be called */
	return;				/* error message later? */

    sa_cleanmain();
    clear();	/* should something else clean up? */
    sa_initialized = FALSE;		/* goodbye... */
}
#endif /* SCAN */
