/* This file Copyright 1992 by Clifford A. Adams */
/* scanart.h
 *
 * Interface to rest of [t]rn
 */

/* later: set of initmode #defines? */

EXT bool sa_initialized INIT(FALSE);	/* Have we initialized? */
EXT bool sa_never_initialized INIT(TRUE); /* Have we ever initialized? */

/* note: sa_in should be checked for returning to SA */
EXT bool sa_in INIT(FALSE);		/* Are we "in" SA? */

EXT bool sa_go INIT(FALSE);		/* go to sa.  Do not pass GO (:-) */
EXT bool sa_go_explicit INIT(FALSE);	/* want to bypass read-next-marked */

EXT bool sa_context_init INIT(FALSE);	/* has context been initialized? */

EXT bool sa_follow INIT(TRUE);		/* follow by default? */
/* explicitly follow until end of thread */
EXT bool sa_follow_temp INIT(FALSE);

#ifdef USETHREADS
EXT bool sa_cross_thread INIT(FALSE);	/* did we cross a thread boundary? */
#endif

/* TRUE if the last command (run through setdef()) was the default */
EXT bool sa_def INIT(FALSE);

/* article # to read, the SA side equivalent to "art" (converted in scanart.c) */
EXT ART_NUM sa_art INIT(0);

/* return codes for sa_main */
	/* go to and enter prior newsgroup */
#define SA_PRIOR (-5)
	/* go to and enter next newsgroup */
#define SA_NEXT (-4)
	/* Fake a command (buf and art already set up) */
#define SA_FAKE (-3)
	/* error, quit out one level */
#define SA_ERR (-2)
	/* quit out one level and clean up... */
#define SA_QUIT (-1)
	/* read article pointed to by art */
#define SA_NORM 0

/* common entry point: returns action code */
int  sa_main ANSI((void));

#ifdef USETHREADS
/* select threads from TRN thread selector */
EXT bool sa_do_selthreads INIT(FALSE);
#endif

/* More articles arrived while reading: (inclusive) range is passed. */
void sa_morearts ANSI((ART_NUM, ART_NUM));

/* normal exit/cleanup procedure */
void sa_cleanup ANSI((void));

/* overall initialization (in case someone else wants to pre-initialize) */
void sa_init ANSI((void));

/* TRUE if read articles are eligible */
/* in scanart.h for world-visibilty */
EXT bool sa_mode_read_elig INIT(FALSE);

/* Display order variable:
 *
 * 1: Arrival order
 * 2: Descending score
 */
EXT int sa_mode_order INIT(1);
/* biggest mode# for sa_mode_order */
EXT int sa_mode_order_max INIT(2);	/* just note: dependence on SCORE */

/* all this stuff moved here for bitflag macro world readability */

/* per-article SA stuff */
typedef struct sa_per {
    /* upgrade when there are more than 32K *subjects* per group. */
    short subj_thread_num;
    char sa_art_status;		/* status bitmap (marked, select, etc...) */
} SA_PER;

/* for each (AOFFSET) article... */
EXT SA_PER *sa_per_art;
