/* This file Copyright 1992 by Clifford A. Adams */
/* score.h
 *
 */

/* RETHINK LOWSCORE: (especially for 16-bit scores?) */
/* score given to unavailable articles */
#define LOWSCORE (-999999)

/* this is the # of articles which are treated as a unit... */
/* reduce below 2 at your own risk... */
/* Note: low values may hurt (interactive) performance */
EXT int scorehunksize INIT(10);

/* array of scores (AOFFSET(artnum))*/
EXT int *scorelist;
/* list of article #s parallel to scores */
EXT int *scoreartlist;

/* array of scores (AOFFSET(artnum))*/
EXT int *ascorelist;
/* list of article #s parallel to scores */
EXT int *ascoreartlist;

/* array of scores used for sorting */
EXT int *sort_scorelist;
/* list of article #s parallel to scores (used for sorting) */
EXT int *sort_scoreartlist;

/* array of indexes to map from articles to the scorelist/scoreartlist */
EXT int *scoreartindx;

/* 1 byte per article.  Note: shorts or longs may be used later... */
/* bit format:
   0-3: for scorefile.c
   4-7: not currently used.
 */
EXT char *scoreflags;
/* specific scoreflag meanings:  (note: bad placement, but where else?) */
/* author has a score (match on FROM: line) */
#define SFLAG_AUTHOR 1

bool kill_thresh_active INIT(FALSE);
int kill_thresh INIT(LOWSCORE);   /* KILL articles at or below this score */

ART_NUM sc_fill_min;	/* minimum art# scored by fill-routine */
bool sc_fill_read INIT(FALSE); /* TRUE if also scoring read arts... */

/* has score been initialized (are we "in" scoring?) */
EXT int sc_initialized INIT(FALSE);

/* changes order of sorting (artnum comparison) when scores are equal */
bool score_newfirst INIT(FALSE);

#ifdef NICEBG
EXT bool sc_mode_nicebg INIT(TRUE);
#endif

#ifdef NEWSFILTER
EXT bool sc_have_newsclip INIT(FALSE);
/* Whether to use NewsClip or not (even if available).  */
EXT bool sc_use_newsclip INIT(FALSE);
#endif

/* If true, save the scores for this group on exit. */
EXT bool sc_savescores INIT(FALSE);
/* filename to save scores in */
EXT char *sc_savefile INIT(Nullch);

/* function declarations. */  /* CLEAN UP LATER */
void sc_init ANSI((bool_int));
void sc_grows ANSI((ART_NUM,ART_NUM));
void sc_cleanup ANSI((void));
int sc_score_art ANSI((ART_NUM,bool_int));
void sc_fill_scorelist ANSI((ART_NUM,ART_NUM)); /* private */
void sc_sort ANSI((void)); /* private */
void sc_dumpscores ANSI((void));
ART_NUM sc_art_higher_score ANSI((ART_NUM));
ART_NUM sc_art_lower_score ANSI((ART_NUM));
ART_NUM sc_art_highest_score ANSI((void));
ART_NUM sc_art_lowest_score ANSI((void));
void sc_lookahead ANSI((bool_int,bool_int));
void sc_keypause ANSI((void));
int sc_percent_scored ANSI((void));
void sc_append ANSI((char *));
/* mark as read all article at or below threshold int... */
void sc_kill_threshold ANSI((int));
void sc_rescore ANSI((void));
void sc_score_cmd ANSI((char *));	/* exec a command */
void sc_load_scores ANSI((void));
void sc_save_scores ANSI((void));
