/* smisc.c
 *
 * Mainly a switching routine
 */

#include "EXTERN.h"
#include "common.h"
#ifdef SCAN
#include "samisc.h"
#include "sadesc.h"
#endif
#include "scan.h"
#include "sgroup.h"
#include "sgmisc.h"
#include "INTERN.h"
#include "smisc.h"

bool
s_eligible(ent)
long ent;
{
    switch (s_cur_type) {
	case S_ART:
	    return(sa_eligible((ART_NUM)ent));
	case S_GROUP:
	    return(sg_eligible(ent));
	default:
	    printf("s_eligible: current type is bad!\n") FLUSH;
	    return(FALSE);
    }
}

long
s_prev(ent)
long ent;
{
    switch (s_cur_type) {
	case S_ART:
	    return(sa_prev((ART_NUM)ent));
	case S_GROUP:
	    return(sg_prev(ent));
	default:
	    return((long)0);
    }
}
long
s_next(ent)
long ent;
{
    switch (s_cur_type) {
	case S_ART:
	    return(sa_next((ART_NUM)ent));
	case S_GROUP:
	    return(sg_next(ent));
	default:
	    return((long)0);
    }
}
long
s_first()
{
    switch (s_cur_type) {
	case S_ART:
	    return(sa_first());
	case S_GROUP:
	    return(sg_first());
	default:
	    return((long)0);
    }
}

long
s_last()
{
    switch (s_cur_type) {
	case S_ART:
	    return(sa_last());
	case S_GROUP:
	    return(sg_last());
	default:
	    return((long)0);
    }
}

/* DOC: article->entry */

/* given an article, returns previous eligible article */
/* returns 0 if no previous eligible article */
long
s_prev_elig(a)
long a;
{
    while((a = s_prev(a)))		/* EQUALS */
	if (s_eligible(a))
	    return a;
    return (long)0;
}

/* given an article, returns next eligible article */
/* returns 0 if no next eligible article */
long
s_next_elig(a)
long a;
{
    while((a = s_next(a)))		/* EQUALS */
	if (s_eligible(a))
	    return a;
    return (long)0;
}

void
s_beep()
{
    putchar(7);
    fflush(stdout);
}

char *
s_get_statchars(ent,line)
long ent;
int line;
{
    switch (s_cur_type) {
	case S_ART:
	    return(sa_get_statchars((ART_NUM)ent,line));
	case S_GROUP:
	    return(sg_get_statchars(ent,line));
	default:
	    return(Nullch);
    }
}

char *
s_get_desc(ent,line)
long ent;
int line;
{
    switch (s_cur_type) {
	case S_ART:
	    return(sa_get_desc((ART_NUM)ent,line));
	case S_GROUP:
	    return(sg_get_desc(ent,line));
	default:
	    return(Nullch);
    }
}

int
s_ent_lines(ent)
long ent;
{
    switch (s_cur_type) {
	case S_ART:
	    return(sa_art_lines((ART_NUM)ent));
	case S_GROUP:
	    return(sg_ent_lines(ent));
	default:
	    return(1);
    }
}
