/* This file Copyright 1992 by Clifford A. Adams */
/* scorefile.h
 *
 * simple proof of concept of author sorting...
 */

typedef struct Sf_Entry {
    int head_type;	/* header # (see head.h) */
    int score;		/* score change */
    char *str1;		/* first string part */
    char *str2;		/* second string part */
    COMPEX *compex;	/* regular expression ptr */
    char flags;		/* to be used later */
} SF_ENTRY;
/* note negative header#s used to indicate special entries... */

EXT int sf_num_entries INIT(0);	/* # of entries */
EXT SF_ENTRY *sf_entries;		/* array of entries */
EXT char **sf_abbr;		/* abbreviations */

/* when true, the scoring routine prints lots of info... */
EXT int sf_score_verbose INIT(FALSE);

EXT bool sf_verbose INIT(TRUE);  /* if true print more stuff while loading */

/* if TRUE, only header types that are cached are scored... */
EXT bool cached_rescore INIT(FALSE);

/* if TRUE, newauthor is active */
EXT bool newauthor_active INIT(FALSE);
/* bonus score given to a new (unscored) author */
EXT int newauthor INIT(0);

/* should we match by pattern? */
EXT int sf_pattern_status INIT(FALSE);

void sf_exclude_file ANSI((char*));

#define DEFAULT_SCOREGROUPS "%p/scores/groups"

void sf_do_file ANSI((char *));
void sf_grow ANSI((void));
void sf_init ANSI((void));
int  sf_score ANSI((ART_NUM));
void sf_clean ANSI((void));
void sf_dump ANSI((char *));
void sf_append ANSI((char *));
char *sf_get_line ANSI((ART_NUM,int));
char *sf_get_filename ANSI((int));

void sf_print_match ANSI((int));
void sf_edit_file ANSI((char *));
